=== debian/changelog ===
ecflow (5.8.4-2build1) kinetic; urgency=medium

  * No-change rebuild to pick up fixed libboost-python dependencies

 -- Graham Inggs <ginggs@ubuntu.com>  Sat, 03 Sep 2022 13:07:52 +0000

ecflow (5.8.4-2) unstable; urgency=medium

  * Fix FTBFS with g++ 12 . Closes: #1016010
  * Standards-Version: 4.6.1; no changes required

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 25 Jul 2022 12:24:28 +0100

ecflow (5.8.4-1) unstable; urgency=medium

  * Nee upstream  release

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 16 May 2022 06:38:26 +0100

ecflow (5.8.3-2) unstable; urgency=medium

  * Don't hard-code PY3VERSIONS. Closes: #1008105

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 23 Mar 2022 11:54:03 +0000

ecflow (5.8.3-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 08 Mar 2022 14:48:10 +0000
